package polyglot.ext.polyj.ast;

import polyglot.ast.*;
import java.util.*;

/**
 * An InstTypeNode is a TypeNode representing the instantiation
 * of a parametric type.
 */
public interface InstTypeNode extends TypeNode
{
    /**
     * The base of the instantiation.
     * e.g., "Map" in "Map[String, int]".
     */
    TypeNode base();
    InstTypeNode base(TypeNode base);

    /**
     * The parameters in the instantiation.
     * These are ParamNodes.
     * e.g., "Map" and "int" in "Map[String, int]".
     */
    List params();
    InstTypeNode params(List params);
}
