package polyglot.ext.polyj.util;

import polyglot.types.*;
import polyglot.util.*;
import polyglot.ext.polyj.types.*;
import polyglot.ext.polyj.visit.*;

public class ParamSigBinding_c implements ParamSigBinding {
    ParamType param;
    ClassType enclosing;
    String name;

    public ParamSigBinding_c(ParamType param, ClassType enclosing,
        PolyJTypeSystem ts) 
    {
        this.param = param;
        this.enclosing = enclosing;
        this.name = PolyJTranslator.adapterMethodName(
            "psig", param, enclosing, ts);
    }

    /**
     * Return the name for the psig method used to access
     * the run-time type of param from within t, which may
     * be a PolyJClassType or an InstType.
     */
    public String name() {
        return name;
    }

    public ParamType param() {
        return param;
    }

    public ClassType enclosing() {
        return enclosing;
    }
}
